#include <stdlib.h>

#define lengthofbuffer 256
#define datalength 200000

float crandom ( int *seed);
void Sub0( float dataareaone[2][lengthofbuffer],
           int *bufferlength,
           int *plateone,
           int *lengthofdata);
void SubS1( float dataareaone[2][lengthofbuffer],
            int *bufferlength,
            int *plateone,
            float *dataareatwo,
            int *platetwo,
            int source[1],
            float *s1);
void SubS2( float dataareaone[2][lengthofbuffer],
            int *bufferlength,
            int *plateone,
            float *dataareathree,
            int *platethree,
            int source[1],
            float *s2);
void SubS3( float dataareaone[2][lengthofbuffer],
            int *bufferlength,
            int *plateone,
            float *dataareafour,
            int *platefour,
            int source[1],
            float *s3);
void SubS4( float *dataareatwo,
            int *platetwo,
            float *dataareathree,
            int *platethree,
            float *dataareafour,
            int *platefour,
            int source[1],
            float *s4);

main( )
{
/*
;
;  This is a main function for the example in section 8.2.2.
;  The example demonstrates a heterogeneous multitasking to compute
;  results: S1, S2, S3, and S4. There are 5 tasks originated:
;     Task 1: generate and send data to Tasks 2, 3, 4, and 5.
;     Task 2: compute S1, and send result to task 4.
;     Task 3: compute S2, and send result to task 4.
;     Task 4: compute S3, and send result to task 4.
;     Task 5: compute S4
;
*/
   static int plateone, platetwo, platethree, platefour;
   int one = 1, two = 2, three = 3;
   static int sourceone[2], sourcetwo[2], sourcethree[2], sourcefour[4];
   static int taskone, tasktwo, taskthree, taskfour, taskfive, k4temp;
   static int bufferlength, lengthofdata, j4temp;
   static float dataareaone[2][lengthofbuffer],dataareatwo,dataareathree;
   static float dataareafour, s1, s2, s3, s4;

/*  initialize  */

   bufferlength = lengthofbuffer;
   lengthofdata = datalength;

/*  create data plates  */

   CreateDataPlate( &plateone, &three );
   CreateDataPlate( &platetwo, &one );
   CreateDataPlate( &platethree, &one );
   CreateDataPlate( &platefour, &one );

/*  define "source"  */

   sourceone[0] = plateone;
   sourceone[1] = 0;
   sourcetwo[0] = plateone;
   sourcetwo[1] = 0;
   sourcethree[0] = plateone;
   sourcethree[1] = 0;
   sourcefour[0] = platetwo;
   sourcefour[1] = platethree;
   sourcefour[2] = platefour;
   sourcefour[3] = 0;

/*  function partitioning  */

   Dispatch_4( &taskone, Sub0, dataareaone,
                               &bufferlength,
                               &plateone,
                               &lengthofdata);
   Dispatch_7( &tasktwo, SubS1, dataareaone,
                                 &bufferlength,
                                 &plateone,
                                 &dataareatwo,
                                 &platetwo,
                                 &sourceone,
                                 &s1);
   Dispatch_7( &taskthree, SubS2, dataareaone,
                                  &bufferlength,
                                  &plateone,
                                  &dataareathree,
                                  &platethree,
                                  &sourcetwo,
                                  &s2);
   Dispatch_7( &taskfour, SubS3, dataareaone,
                                 &bufferlength,
                                 &plateone,
                                 &dataareafour,
                                 &platefour,
                                 &sourcethree,
                                 &s3);
   Dispatch_8( &taskfive, SubS4, &dataareatwo,
                                 &platetwo,
                                 &dataareathree,
                                 &platethree,
                                 &dataareafour,
                                 &platefour,
                                 &sourcefour,
                                 &s4);

/*  wait for completion of tasks  */

   for ( j4temp = 0; j4temp < 5; j4temp ++ )
   {
      WaitForAnyTask(&k4temp);
      TerminateTask(&k4temp);
   }

/*  delete data plates  */

   DeleteDataPlate( &plateone );
   DeleteDataPlate( &platetwo );
   DeleteDataPlate( &platethree );
   DeleteDataPlate( &platefour );

/*  output  */

   printf("S1= %f\n", s1);
   printf("S2= %f\n", s2);
   printf("S3= %f\n", s3);
   printf("S4= %f\n", s4);
}

void Sub0( float dataareaone[2][lengthofbuffer],
           int *bufferlength,
           int *plateone,
           int *lengthofdata)
{
/*
;
;  function to generate array A by a pseudo-random procedure
;  (A)Parameters
;     1.dataareaone: area one for data interchange,
;                    dimension[2][lengthofbuffer]
;     2.bufferlength: buffer length
;     3.plateone: data plate carrying the information to access data
;                 in area one
;     4.lengthofdata: length of array A
;
*/

/*  private data  */

   int j4temp$, k4temp$, argu_1$, argu_2$, argu_3$, seed$;

/*  find a space to write data  */

   seed$ = 666666;
   argu_1$ = 1;
   for ( j4temp$ = 0;
         j4temp$ < *lengthofdata;
         j4temp$ = j4temp$ + *bufferlength)
   {
         switch (argu_2$)
         {
            case 0:
               argu_2$ = 1;
               break;
            default:
               argu_2$ = 0;
               break;
         }

/*  generate data  */

         argu_3$ = __min( j4temp$ + *bufferlength - 1, *lengthofdata) - 
                   j4temp$ + 1;
         for ( k4temp$ = 0; k4temp$ < argu_3$; k4temp$ ++ )
               dataareaone[argu_2$][k4temp$] = crandom( &seed$ );

/*  post a data plate  */

         PostDataPlate( plateone, &argu_1$, &argu_2$, &argu_3$);
   }

/*  post message of completion  */

   argu_1$ = 2;
   PostDataPlate( plateone, &argu_1$, &argu_2$, &argu_3$);
}
      
      
void SubS1( float dataareaone[2][lengthofbuffer],
            int *bufferlength,
            int *plateone,
            float *dataareatwo,
            int *platetwo,
            int source[1],
            float *s1)
{
/*
;
;
;  function to compute S1, and forward the result to Task_4 when
;  computation is complete
;  (A)Parameters:
;     1.dataareaone: area one for data interchange,
;                    dimension[2][bufferlength]
;     2.bufferlength: buffer length of data area one
;     3.plateone: data plate carrying the information to access data
;                 in area one
;     4.dataareatwo: variable for data interchange
;     5.platetwo: data plate carrying the information to access data
;                 in area two
;     6.source: list of data plates that will sent to the task,
;               dimension[*]. The list is terminated with a null value.
;     7.s1: result
;
*/
   int id$, argu_1$, argu_2$, argu_3$, j4temp$;

/*  initialize  */

   *s1 = 0.0;

/*  read data plates  */

label_10:    
   ReadDataPlate( source, &id$, &argu_1$, &argu_2$, &argu_3$);

/*  compute S1  */

   if( id$ == *plateone)
   {
      switch (argu_1$)
      {
         case 1:
                 for ( j4temp$ = 0; j4temp$ < argu_3$; j4temp$ ++ )
                       *s1 = *s1 + dataareaone[argu_2$][j4temp$];
                 break;

/*  send result and forward message to task 4  */

         case 2:
                 *dataareatwo = *s1;
                 j4temp$ = 1;
                 PostDataPlate( platetwo, &j4temp$, &j4temp$, &j4temp$);
                 j4temp$ = 2;
                 PostDataPlate( platetwo, &j4temp$, &j4temp$, &j4temp$);
                 FinishDataPlate( &id$ );
                 return;
      }
   }
   FinishDataPlate( &id$ );
   goto label_10;
}
      
      
void SubS2( float dataareaone[2][lengthofbuffer],
            int *bufferlength,
            int *plateone,
            float *dataareathree,
            int *platethree,
            int source[1],
            float *s2)
{
/*
;
;  function to compute S2, and forward the result to Task_4 when
;  computation is complete
;  (A)Parameters:
;     1.dataareaone: area one for data interchange,
;                    dimension[2][bufferLength]
;     2.bufferlength: buffer length of data area one
;     3.plateone: data plate carrying the information to access data
;                 in area one
;     4.dataareathree: variable for data interchange
;     5.platethree: data plate carrying the information to access data
;                   in area three
;     6.source: list of data plates that will sent to the task,
;               dimension[*]. The list is terminated with a null value.
;     7.s2: result
;
*/

/*  private variables  */

   int id$, argu_1$, argu_2$, argu_3$, j4temp$;

/*  initialize  */

   *s2 = 0.0;

/*  read data plates  */

label_10:    
   ReadDataPlate( source, &id$, &argu_1$, &argu_2$, &argu_3$);

/*  compute S2  */

   if( id$ == *plateone)
   {
      switch (argu_1$)
      {
         case 1:
                 for ( j4temp$ = 0; j4temp$ < argu_3$; j4temp$ ++ )
                       *s2 = *s2 + dataareaone[argu_2$][j4temp$] *
                                   dataareaone[argu_2$][j4temp$];
                 break;

/*  send result and forward message to task 4  */

         case 2:
                 *dataareathree = *s2;
                 j4temp$ = 1;
                 PostDataPlate( platethree, &j4temp$, &j4temp$, &j4temp$);
                 FinishDataPlate( &id$ );
                 return;
      }
   }
   FinishDataPlate( &id$ );
   goto label_10;
}
      
      
void SubS3( float dataareaone[2][lengthofbuffer],
            int *bufferlength,
            int *plateone,
            float *dataareafour,
            int *platefour,
            int source[1],
            float *s3)
{
/*
;
;  function to compute S3, and forward the result to Task_4 when
;  computation is complete
;  (A)Parameters
;     1.dataareaone: area one for data interchange,
;                    dimension[2][bufferLength]
;     2.bufferlength: buffer length of data area one
;     3.plateone: data plate carrying the information to access data
;                 in area one
;     4.dataareafour: variable for data interchange
;     5.platefour: data plate carrying the information to access data
;                  in area four
;     6.source: list of data plates that will sent to the task,
;               dimension[*]. The list is terminated with a null value.
;     7.s3: result
;
*/

/*  private variables  */

   int id$, argu_1$, argu_2$, argu_3$, j4temp$;

/*  initialize  */

   *s3 = 0.0;

/*  read data plates  */

label_10:    
   ReadDataPlate( source, &id$, &argu_1$, &argu_2$, &argu_3$);

/*  compute S3  */

   if(  id$ == *plateone)
   {
      switch (argu_1$)
      {
         case 1:
                 for ( j4temp$ = 0; j4temp$ < argu_3$; j4temp$ ++ )
                       *s3 = *s3 + dataareaone[argu_2$][j4temp$] *
                                   dataareaone[argu_2$][j4temp$] *
                                   dataareaone[argu_2$][j4temp$];
                 break;

/*  send result and forward message to task 4  */

         case 2:
                 *dataareafour= *s3;
                 j4temp$ = 1;
                 PostDataPlate( platefour, &j4temp$, &j4temp$, &j4temp$);
                 FinishDataPlate( &id$ );
                 return;
      }
   }
   FinishDataPlate( &id$);
   goto label_10;
}
      
      
void SubS4( float *dataareatwo,
            int *platetwo,
            float *dataareathree,
            int *platethree,
            float *dataareafour,
            int *platefour,
            int source[1],
            float *s4)
{
/*
;
;  function to compute S4
;  (A)Parameters:
;     1.dataareatwo: variable for data interchange
;     2.platetwo: data plate carrying the information to access data
;                 in area two
;     3.dataareathree: variable for data interchange
;     4.platethree: data plate carrying the information to access data
;                   in area three
;     5.dataareafour: variable for data interchange
;     6.platefour: data plate carrying the information to access data
;                  in area four
;     7.source: list of data plates that will sent to the task,
;               dimension[*]. The list is terminated with a null value.
;     8.s4: result
;
*/

/*  private variables  */

   int id$, argu_1$, argu_2$, argu_3$, coming$, done$;
   float s1$, s2$, s3$;

/*  initialize  */

   *s4 = 0.0;
   coming$ = 0;
   done$ = 0;

/*  read data plates  */

label_10:    
   ReadDataPlate( source, &id$, &argu_1$, &argu_2$, &argu_3$);

/*  read data on plate two  */

   if( id$ == *platetwo)
   {
      FinishDataPlate( &id$ );
      switch (argu_1$)
      {
         case 1:
                 s1$ = *dataareatwo;
                 coming$ = coming$ + 1;
                 if( coming$ == 3)
                 {
                    *s4= s1$ * s2$ + s3$;
                    coming$ = 4;
                    if( done$ == 1 ) return;
                 }
                 break;
         case 2:
                 if( coming$ == 4 ) return;
                 done$ = 1;
      }
   }

/*  read data on plate three  */

   else if( id$ == *platethree)
   {
      s2$ = *dataareathree;
      coming$ = coming$ + 1;
      FinishDataPlate( &id$ );
      if( coming$ == 3)
      {
         *s4 = s1$ * s2$ + s3$;
         coming$ = 4;
         if( done$ == 1) return;
      }
   }

/*  read data on plate four  */

   else if( id$ == *platefour)
   {
      s3$ = *dataareafour;
      coming$ = coming$ + 1;
      FinishDataPlate( &id$ );
      if( coming$ == 3)
      {
         *s4 = s1$ * s2$ + s3$;
         coming$ = 4;
         if( done$ == 1) return;
      }
   }
   goto label_10;
}

#define m 2147483647
#define a 16807
float crandom(int *seed)
{
   double rtempa, rtempb;
   float rtemp;
   int itemp;
   rtempa = (double) *seed * a;
   itemp = (int) (rtempa / (double) m);
   rtempb = (double) m * (double) itemp;
   *seed = (int) (rtempa - rtempb);
   rtemp = (double) *seed / (double) m;
   return rtemp;
}
